Subject: Re: bug#41532: Why use the mouse in Emacs?

From: Dmitry Alexandrov <[email-masked]>
Date: Wed, 27 May 2020 06:57:10 +0300

Drew Adams <[email-masked]> wrote:
> The difference from some other applications, I think, is that some applications pretty much _require_ you to use a mouse.

Yep, and thatʼs partly true even for Emacs.  Especially, when itʼs built with no GTK.  IIRC, Lucid popup menus once were usable without mouse, but they are not anymore for some reason, while --with-x-toolkit=no menus have never been.

There is M-x tmm-menubar, of course, but besides main menu there are also context menus.  I have not done a good research, but at first sight Iʼve failed to figure out how to access them without falling back to mouse.

>> the Emacs graphical interface [in sense of use-dialog-box and use-file-dialog] is half broken.
>
> How so?  Specifically, what's the problem?

One thing that frustrated me once upon a time, was a dialog window I got trying to close the last frame of server-less Emacs (FWIW, no mouse was involved), that asked the usual question about saving buffers, blocking the session, but it had _no_ ‘cancel’ button.

I could try to press ‘close window’ again, but it had not been quite obvious which of two UI design patterns Emacs would follow here:
— closing the dialog window = cancel (this happens to be the case, after all);
— repeating the destructive command twice = force it (like e. g. C-d in Bash when there are background jobs) — definitely not what I wanted.

Perhaps, I was too stupid, but it took me a certain time to came to idea, that toolkit dialogs in Emacs might accept C-g as well (yes, they do).